unit ClientMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, db, Grids;

type
  TfrmClientMain = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure HintTimeTimer(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnModifyClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    function  LocateText(Sender: TObject;ADisplayField,AKeyField:string):Variant;
    procedure edtSearchEnter(Sender: TObject);
    procedure edtSearchChange(Sender: TObject);
    procedure edtSearchKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SetState(Value:integer);
    procedure SetCompsEnabled(Sender: TObject; State:integer);
    procedure dbgSearchDblClick(Sender: TObject);
    procedure pcDataChanging(Sender: TObject;var AllowChange: Boolean);
    procedure Init;
  private
    { Private declarations }
  public
    { Public declarations }
    FHWin:THintWindow;
    NotInSearch:boolean;
    FLocated:boolean;
    FtsEdit:TTabSheet;
    FtsSearch:TTabSheet;
    FStrRelations:TStringList;
    FRelations:TStringList;
    FState:integer;
    FDID:Integer;
  end;

var
  frmClientMain: TfrmClientMain;

implementation

uses ZEDit,ZEDPicker,ZEDChxBox, ExtCtrls, ClientMainDataModule, TypInfo, variants;
{$R *.DFM}

procedure TfrmClientMain.HintTimeTimer(Sender: TObject);
begin
  FHWin.ReleaseHandle;
  TTimer(Sender).Enabled:=False;
end;

procedure TfrmClientMain.btnSearchClick(Sender: TObject);
var cv:integer;
    lvsql,lvKeyField,lvTextValue,lvDictionary:string;
    lvValue:Variant;
    lvRelation:integer;
    lvEmpty:boolean;
begin
  if assigned(FtsSearch) then
  with dmClientMain.qryGetMainData do
  Begin
    Close;
    SQL.Text:='Select * From Document';
    For cv:=0 to FtsSearch.ControlCount-1 do
    Begin
      lvRelation:=FStrRelations.IndexOf(VarToStr(GetPropValue(FtsSearch.Controls[cv],'Relation')));
      if lvRelation>-1 then
      Begin
        lvTextValue:=VarToStr(GetPropValue(FtsSearch.Controls[cv],'Text'));
        try
          lvEmpty:=GetPropValue(FtsSearch.Controls[cv],'Empty');
        except
          lvEmpty:=false;
        end;
        if not Boolean(lvEmpty) or (lvTextValue<>'') then
        Begin
          try
            lvKeyField:=GetPropValue(FtsSearch.Controls[cv],'KeyField');
          except
            lvKeyField:='';
          end;
          try
            lvDictionary:=GetPropValue(FtsSearch.Controls[cv],'Dictionary');
          except
            lvDictionary:='';
          end;
          try
            lvValue:=GetPropValue(FtsSearch.Controls[cv],'FieldValue');
          except
            lvValue:='';
          end;
          if SQL.Count>1 then
            SQL.Add('and')
          else
            SQL.Add('Where');
          if (lvDictionary<>'') then
          Begin
            if (lvRelation>7) and VarIsNull(lvValue) then
            Begin
              Inc(lvRelation,2);
              lvSQL:=dmClientMain.GenerateDictionaryFilter(lvDictionary,lvTextValue,true);
            End
            else
              lvSQL:=dmClientMain.GenerateDictionaryFilter(lvDictionary,lvValue,false);
          End
          else
            lvSQL:=lvValue;
          SQL.Add(lvKeyField+' '+FRelations[lvRelation]+' '+lvSQL);
        End;
      End;
    End;
    {$IFDEF SQLDebug}
    SQL.SaveToFile('Debug.sql') ;
    {$ENDIF}
    Open;
  End
end;

procedure TfrmClientMain.btnNewClick(Sender: TObject);
begin
  SetState(3);
end;

procedure TfrmClientMain.btnSaveClick(Sender: TObject);
var cv:integer;
    lvFieldNames:string;
    lvFieldValues:string;
    lvValid:Boolean;
    lvFieldType:integer;
    lvEmpty:Variant;
    lvDictID,lvDict,lvTextValue:string;
begin
  if FState=3 then
  Begin
    for cv:=0 to FtsEdit.ControlCount-1 do
    Begin
      try
        lvEmpty:=GetPropValue(FtsEdit.Controls[cv],'Empty');
      except
        lvEmpty:=null;
      end;
      if not VarIsNull(lvEmpty) then
      Begin
        try
          lvDict:=VarToStr(GetPropValue(FtsEdit.Controls[cv],'Dictionary'));
        except
          lvDict:='';
        end;
        try
          lvTextValue:=VarToStr(GetPropValue(FtsEdit.Controls[cv],'Text'));
        except
          lvTextValue:='';
        end;
        try
          lvValid:=GetPropValue(FtsEdit.Controls[cv],'Validate');
        except
          lvValid:=false;
        end;
        try
          lvFieldType:=GetPropValue(FtsEdit.Controls[cv],'FieldType');
        except
          lvFieldType:=-1;
        end;
        if (lvEmpty='False') and lvValid then
        Begin
          if lvFieldNames<>'' then
          Begin
            try
              lvFieldNames:=lvFieldNames+','+GetPropValue(FtsEdit.Controls[cv],'KeyField');
            except
              lvFieldNames:='';
            end;
            try
              if lvFieldType in [1,2] then
                lvFieldValues:=lvFieldValues+','#39+VarToStr(GetPropValue(FtsEdit.Controls[cv],'FieldValue'))+#39
              else
                lvFieldValues:=lvFieldValues+','+VarToStr(GetPropValue(FtsEdit.Controls[cv],'FieldValue'))
            except
              lvFieldValues:='';
            end;
          End
          else
          Begin
            try
              lvFieldNames:=GetPropValue(FtsEdit.Controls[cv],'KeyField');
            except
              lvFieldNames:='';
            end;
            try
              if lvFieldType in [1,2] then
                lvFieldValues:=#39+VarToStr(GetPropValue(FtsEdit.Controls[cv],'FieldValue'))+#39
              else
                lvFieldValues:=VarToStr(GetPropValue(FtsEdit.Controls[cv],'FieldValue'));
            except
              lvFieldValues:='';
            end;
          End;
        End
        else
        if (lvDict<>'') and (lvTextValue<>'') and lvValid then
        Begin
          lvDictID:=dmClientMain.GetDictionaryGroupID(lvDict);
          dmClientMain.cmdInsertData.CommandText:='Insert Into Dictionary (Caption,DictionaryGroupID) Values ('#39+lvTextValue+#39','+lvDictID+')';
          dmClientMain.cmdInsertData.Execute;
          dmClientMain.qrySearch.Close;
          dmClientMain.qrySearch.SQL.Text:='Select @@IDENTITY';
          dmClientMain.qrySearch.Open;
          if lvFieldNames<>'' then
          Begin
            lvFieldNames:=lvFieldNames+','+GetPropValue(FtsEdit.Controls[cv],'KeyField');
            if lvFieldType=1 then
              lvFieldValues:=lvFieldValues+','#39+dmClientMain.qrySearch.Fields[0].asString+#39
            else
              lvFieldValues:=lvFieldValues+','+dmClientMain.qrySearch.Fields[0].asString;
          End
          else
          Begin
            lvFieldNames:=GetPropValue(FtsEdit.Controls[cv],'KeyField');
            if lvFieldType=1 then
              lvFieldValues:=#39+dmClientMain.qrySearch.Fields[0].asString+#39
            else
              lvFieldValues:=dmClientMain.qrySearch.Fields[0].asString;
          End;
        End
        else
        if (GetPropValue(FtsEdit.Controls[cv],'Required')='True') then
        Begin
          TWinControl(FtsEdit.Controls[cv]).SetFocus;
          Exit;
        End;
      End;
    End;
    if lvFieldNames<>'' then
    Begin
      dmClientMain.cmdInsertData.CommandText:='Insert Into Document ('+lvFieldNames+') Values ('+lvFieldValues+')';
      dmClientMain.cmdInsertData.Execute;
    End;
  End
  else
  Begin //Update
    for cv:=0 to FtsEdit.ControlCount-1 do
    Begin
      try
        lvEmpty:=GetPropValue(FtsEdit.Controls[cv],'Empty');
      except
        lvEmpty:=null;
      end;
      if not VarIsNull(lvEmpty) then
      Begin
        try
          lvDict:=VarToStr(GetPropValue(FtsEdit.Controls[cv],'Dictionary'));
        except
          lvDict:='';
        end;
        try
          lvTextValue:=VarToStr(GetPropValue(FtsEdit.Controls[cv],'Text'));
        except
          lvTextValue:='';
        end;
        try
          lvValid:=GetPropValue(FtsEdit.Controls[cv],'Validate');
        except
          lvValid:=false;
        end;
        try
          lvFieldType:=GetPropValue(FtsEdit.Controls[cv],'FieldType');
        except
          lvFieldType:=-1;
        end;
        if (lvEmpty='False') and lvValid then
        Begin
          if lvFieldNames<>'' then
            lvFieldNames:=lvFieldNames+','+GetPropValue(FtsEdit.Controls[cv],'KeyField')+' = '
          else
            lvFieldNames:=GetPropValue(FtsEdit.Controls[cv],'KeyField')+' = ';
          if lvFieldType in [1,2] then
            lvFieldNames:=lvFieldNames+#39+VarToStr(GetPropValue(FtsEdit.Controls[cv],'FieldValue'))+#39
          else
            lvFieldNames:=lvFieldNames+VarToStr(GetPropValue(FtsEdit.Controls[cv],'FieldValue'));
        End
        else
        if (lvDict<>'') and (lvTextValue<>'') and lvValid then
        Begin
          lvDictID:=dmClientMain.GetDictionaryGroupID(lvDict);
          dmClientMain.cmdInsertData.CommandText:='Insert Into Dictionary (Caption,DictionaryGroupID) Values ('#39+lvTextValue+#39','+lvDictID+')';
          dmClientMain.cmdInsertData.Execute;
          dmClientMain.qrySearch.Close;
          dmClientMain.qrySearch.SQL.Text:='Select @@IDENTITY';
          dmClientMain.qrySearch.Open;
          if lvFieldNames<>'' then
            lvFieldNames:=lvFieldNames+','+GetPropValue(FtsEdit.Controls[cv],'KeyField')+' = '
          else
            lvFieldNames:=GetPropValue(FtsEdit.Controls[cv],'KeyField')+' = ';
          if lvFieldType=1 then
            lvFieldNames:=lvFieldNames+#39+dmClientMain.qrySearch.Fields[0].asString+#39
          else
            lvFieldNames:=lvFieldNames+dmClientMain.qrySearch.Fields[0].asString;
        End
        else
        if (GetPropValue(FtsEdit.Controls[cv],'Required')='True') then
        Begin
          TWinControl(FtsEdit.Controls[cv]).SetFocus;
          Exit;
        End
        else
        Begin
          if lvFieldNames<>'' then
            lvFieldNames:=lvFieldNames+','+GetPropValue(FtsEdit.Controls[cv],'KeyField')+' = null '
          else
            lvFieldNames:=GetPropValue(FtsEdit.Controls[cv],'KeyField')+' = null ';
        End;
      End;
    End;
    if lvFieldNames<>'' then
    Begin
      dmClientMain.cmdInsertData.CommandText:='Update Document Set '+lvFieldNames+' Where DocumentID = '+IntToStr(FDID);
      dmClientMain.cmdInsertData.Execute;
      btnSearchClick(nil);
    End;
  End;
  SetState(1);
end;

procedure TfrmClientMain.btnCancelClick(Sender: TObject);
begin
  if FState=3 then
    SetState(0)
  else
  Begin
    SetState(1);
    dbgSearchDblClick(nil);
  End;
end;

procedure TfrmClientMain.btnModifyClick(Sender: TObject);
begin
  SetState(2);
end;

procedure TfrmClientMain.btnPrintClick(Sender: TObject);
begin
  //rem
end;

function TfrmClientMain.LocateText(Sender: TObject;ADisplayField,AKeyField:string):Variant;
var lvSelStart:integer;
begin //Mez rtkre keress, s kiegszts
  if dmClientMain.qrySearch.Locate(ADisplayField,StringReplace(TCustomEdit(Sender).Text,'%',' ',[rfReplaceAll]),[loCaseInsensitive,loPartialKey]) then
  Begin
    lvSelStart:=TCustomEdit(Sender).SelStart;
    TCustomEdit(Sender).Text:=trim(dmClientMain.qrySearch.FieldByName(ADisplayField).asString);
    TCustomEdit(Sender).SelStart:=lvSelStart;
    TCustomEdit(Sender).SelLength:=Length(TCustomEdit(Sender).Text)-lvSelStart;
    Result:=dmClientMain.qrySearch.FieldByName(AKeyField).Value;
  End
  else
    Result:=Null;
end;

procedure TfrmClientMain.edtSearchChange(Sender: TObject);
begin
  if TWinControl(Sender).Focused and NotInSearch then
  Begin
    if dmClientMain.qrySearch.Active then
    try
      NotInSearch:=False;
      SetPropValue(Sender,'FieldValue',LocateText(Sender,'Caption','DictionaryID'));
      NotInSearch:=True;
    except
      SetPropValue(Sender,'FieldValue',null);
      NotInSearch:=True;
    end;
  End;
end;

procedure TfrmClientMain.edtSearchKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if TWinControl(Sender).Parent.Name='tsEdit' then
  if FState=0 then
    SetState(3)
  else
  if FState=1 then
    SetState(2);
  if Key=VK_BACK then
  with Sender as TEdit do
  Begin
    if (SelStart>0) and (SelLength>0) then
    Begin
      SelStart:=SelStart-1;
      SelLength:=Length(Text)-SelStart;
    End;
  End
end;

procedure TfrmClientMain.FormShow(Sender: TObject);
begin
  FtsEdit:=TTabSheet(FindComponent('tsEdit'));
  FtsSearch:=TTabSheet(FindComponent('tsSearch'));
  FStrRelations:=TStringList.Create;
  with FStrRelations do
  Begin
    Add('Egyenl');
    Add('NemEgyenl');
    Add('res');
    Add('Nemres');
    Add('Kisebb');
    Add('Nagyobb');
    Add('KisebbEgyenl');
    Add('NagyobbEgyenl');
    Add('Hasonl');
    Add('NemHasonl');
  End;

  FRelations:=TStringList.Create;
  with FRelations do
  Begin
    Add('=');
    Add('<>');
    Add('is null');
    Add('is not null');
    Add('<');
    Add('>');
    Add('<=');
    Add('>=');
    Add('like');
    Add('Not like');
    Add('in');
    Add('Not in');
  End;

  Init;
  SetState(0);
end;

procedure TfrmClientMain.SetCompsEnabled(Sender:TObject; State:integer);
begin
  try
    if not VarIsNull(GetPropValue(Sender,'State')) then
      SetPropValue(Sender,'State',State);
  except
  end;
end;

procedure TfrmClientMain.SetState(Value: integer);
var cv:integer;
begin
  FState:=Value;
  if assigned(FtsEdit) then
  for cv:=0 to FtsEdit.ControlCount-1 do
    SetCompsEnabled(FtsEdit.Controls[cv],Value);
end;

procedure TfrmClientMain.dbgSearchDblClick(Sender: TObject);
var lvAllowCh:boolean;
begin
  lvAllowCh:=True;
  pcDataChanging(FtsEdit.PageControl,lvAllowCh);
  if lvAllowCh then
    FtsEdit.PageControl.ActivePage:=FtsEdit;
end;

procedure TfrmClientMain.edtSearchEnter(Sender: TObject);
var lvDictID:String;
begin
  with dmClientMain,qrySearch do
  Begin
    lvDictID:=GetDictionaryGroupID(GetPropValue(Sender,'Dictionary'));
    Close;
    SQL.Text:='Select DictionaryID,Caption from Dictionary where DictionaryGroupID = '+lvDictID;
    Open;
    NotInSearch:=True;
  End;
end;

procedure TfrmClientMain.Init;
var lvDict:string;
    cv:integer;
    lvMethod:TMethod;
begin
  lvMethod.Data:=frmClientMain;
  for cv:=0 to frmClientMain.ComponentCount-1 do
  Begin
    try
      lvDict:=VarToStr(GetPropValue(frmClientMain.Components[cv],'Dictionary'));
    except
      lvDict:='';
    end;
    if lvDict<>'' then
    Begin
      lvMethod.Code:=frmClientMain.MethodAddress('edtSearchEnter');
      SetMethodProp(frmClientMain.Components[cv],'OnEnter',lvMethod);

      lvMethod.Code:=frmClientMain.MethodAddress('edtSearchChange');
      SetMethodProp(frmClientMain.Components[cv],'OnChange',lvMethod);

      lvMethod.Code:=frmClientMain.MethodAddress('edtSearchKeyDown');
      SetMethodProp(frmClientMain.Components[cv],'OnKeyDown',lvMethod);
    End
  End;
  lvMethod.Code:=frmClientMain.MethodAddress('dbgSearchDblClick');
  SetMethodProp(FindComponent('dbgSearch'),'OnDblClick',lvMethod);

  lvMethod.Code:=frmClientMain.MethodAddress('pcDataChanging');
  SetMethodProp(FindComponent('pcData'),'OnChanging',lvMethod);
end;

procedure TfrmClientMain.pcDataChanging(Sender: TObject;
  var AllowChange: Boolean);
var cv:integer;
    lvKeyField:Variant;
begin
  AllowChange:=FState<2;
  if (FState=1) and (TPageControl(Sender).ActivePage.name='tsEdit') then
    dmClientMain.qryGetMainData.Locate('DocumentID',FDID,[])
  else
  if dmClientMain.qryGetMainData.Active and (dmClientMain.qryGetMainData.RecordCount>0) and assigned(FtsEdit) then
  Begin
    FDID:=dmClientMain.qryGetMainData.Fields[0].asInteger;
    for cv:=0 to FtsEdit.ControlCount-1 do
    Begin
      lvKeyField:=GetPropValue(FtsEdit.Controls[cv],'KeyField');
      if not VarIsNull(lvKeyField) then
        if dmClientMain.isDictionaryField(lvKeyField) then
        Begin
          SetPropValue(FtsEdit.Controls[cv],'Text',dmClientMain.qryGetMainData.FieldByName('_'+lvKeyField).Value);
          SetPropValue(FtsEdit.Controls[cv],'FieldValue',dmClientMain.qryGetMainData.FieldByName(lvKeyField).Value);
        End
        else
          SetPropValue(FtsEdit.Controls[cv],'FieldValue',dmClientMain.qryGetMainData.FieldByName(lvKeyField).Value);
    End;
    SetState(1);
  End;
end;

end.
