unit ClientMainDataModule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, ADODB, DBGrids, Grids;

type
  TdmClientMain = class(TDataModule)
    ADOConnection: TADOConnection;
    qryGetUserData: TADOQuery;
    qrySearch: TADOQuery;
    qryGetMainData: TADOQuery;
    dtsGetMainData: TDataSource;
    dstSearch: TDataSource;
    cmdInsertData: TADOCommand;
    procedure DataModuleCreate(Sender: TObject);
    procedure Init;
    procedure qryGetUserDataCalcFields(DataSet: TDataSet);
  private
    { Private declarations }
    FUserID:integer;
  public
    { Public declarations }
    procedure SelfLoader(BS:TStream);
    function GenerateDictionaryFilter(ADictionaryName:String;Value:Variant;UseLike:Boolean): String;
    function GetDictionaryGroupID(ADictionaryName:string):string;
    function GetFieldCaption(AFieldName:String):String;
    function DecodeField(ADictinaryID:String):String;
    function isDictionaryField(AFieldName:String):boolean;
  end;

var
  dmClientMain: TdmClientMain;

implementation

uses ZEDit, ZEDPicker, ZEDChxBox, ZEDText, ZEDBtn, comctrls, extctrls, stdctrls,
     Buttons, Menus, ClientMain, LoginMain, TypInfo, contnrs, variants;

{$R *.DFM}

procedure TdmClientMain.DataModuleCreate(Sender: TObject);
var BS:TStream;
begin
  frmPasswordDlg:=TfrmPasswordDlg.Create(nil);
  if frmPasswordDlg.ShowModal = mrOK then
  with qryGetUserData do
  try
    ADOConnection.ConnectionString:='FILE NAME='+ExtractFilePath(ParamStr(0))+'ArchiTekaDSC.udl';
    ADOConnection.Connected:=True;
    Parameters.ParamByName('@UserLogin').Value:=frmPasswordDlg.edtLoginName.Text;
    Parameters.ParamByName('@UserPasswd').Value:=frmPasswordDlg.edtPasswd.Text;
    Open;
    if RecordCount=1 then
    try
      FUserID:=FieldByName('UserID').asInteger;
      BS:=qryGetUserData.CreateBlobStream(qryGetUserData.FieldByName('FormData'),bmRead);
      SelfLoader(BS);
      Init;
    finally
      FreeAndNil(BS);
    End;
  except
    frmPasswordDlg.Free;
    Application.Terminate;
  End
  else
  Begin
    frmPasswordDlg.Free;
    Application.Terminate;
  End
end;

procedure TdmClientMain.SelfLoader(BS:TStream);
var MS:TStream;
    lvEnd:integer;
begin
  try
    MS:=TMemoryStream.Create;
    ObjectTextToBinary(BS,MS);
    lvEnd:=0;
    MS.WriteBuffer(lvEnd,SizeOf(lvEnd));
    MS.Seek(0,soFromBeginning);
    Application.CreateForm(TfrmClientMain,frmClientMain);
    MS.ReadComponent(frmClientMain);
  finally
    FreeAndNil(MS);
  end;
end;

function TdmClientMain.GenerateDictionaryFilter(ADictionaryName: String;Value:Variant;UseLike:Boolean): String;
var lvDictID:string;
begin
  if VarIsNull(value) then
    result:='null'
  else
  with dmClientMain.qrySearch do
  Begin
    Value:=VarToStr(Value);
    Result:='';
    if ADictionaryName<>'' then
      lvDictID:=GetDictionaryGroupID(ADictionaryName);

    SQL.Text:='Select * from Dictionary';
    if lvDictID<>'' then
      SQL.Add('where DictionaryGroupID = '+lvDictID);

    if Value<>'' then
    Begin
      if SQL.Count>1 then
        SQL.Add(' And ')
      else
        SQL.Add('Where');

      if UseLike then
        SQL.Add(' Caption Like '#39'%'+Value+'%'#39)
      else
        SQL.Add(' DictionaryID = '+Value);
    End;
    Open;
    if not UseLike and not EOF then
      Result:=Fields[0].AsString
    else
    Begin
      if not EOF then
      Begin
        Result:='(';
        Result:=Result+Fields[0].AsString;
        Next;
        While not EOF do
        Begin
          Result:=Result+','+Fields[0].AsString;
          Next;
        End;
        Result:=Result+')';
      End
      else
        result:='(null)';
    End;
  End;
end;

function TdmClientMain.GetDictionaryGroupID(ADictionaryName: string): string;
begin
  with qrySearch do
  Begin
    Close;
    SQL.Text:='Select DictionaryGroupID from DictionaryGroup where DictionaryGroupName = '#39+ADictionaryName+#39;
    Open;
    Result:=Fields[0].AsString;
    Close;
  end;
end;

procedure TdmClientMain.Init;
Type TLocalClass=class of TField;
var lvClassList:TClassList;
    lvFieldNames:TStringList;
    lvField:TField;
    lvColumn:TColumn;
    cv:integer;
begin
  //dmClientMain.cmdInsertData.CommandText:='Set DATEFORMAT ymd';
  //dmClientMain.cmdInsertData.Execute;
  DateSeparator:='-';
  ShortDateFormat:='yyyy-mm-dd';
  lvClassList:=TClassList.Create;
  lvFieldNames:=TStringList.Create;
  with qrySearch do
  Begin
    Close;
    SQL.Text:='Select * from Document where DocumentID is null';
    Open;
    for cv:=0 to Fields.Count-1 do
    Begin
      lvClassList.Add(Fields[cv].ClassType);
      lvFieldNames.Add(Fields[cv].FieldName);
    End;
    Close;
    SQL.Text:='Select * from Fields';
    Open;
    for cv:=0 to lvFieldNames.Count-1 do
    Begin
      lvField:=TLocalClass(lvClassList[cv]).Create(dmClientMain.qryGetMainData);
      TField(lvField).FieldName:=lvFieldNames[cv];
      TField(lvField).DataSet:=dmClientMain.qryGetMainData;
      if isDictionaryField(lvFieldNames[cv]) then
      Begin
        TField(lvField).Visible:=False;
        lvField:=TStringField.Create(dmClientMain.qryGetMainData);
        TField(lvField).FieldName:='_'+lvFieldNames[cv];
        TField(lvField).Calculated:=True;
        TField(lvField).FieldKind:=fkCalculated;
        TField(lvField).DataSet:=dmClientMain.qryGetMainData;
      End;
      if lvFieldNames[cv]='DocumentID' then
        TField(lvField).DisplayLabel:='ID'
      else
        TField(lvField).DisplayLabel:=StringReplace(GetFieldCaption(lvFieldNames[cv]),':','',[]);
      with (frmClientMain.FindComponent('dbgSearch') as TDBGrid) do
      Begin
        lvColumn:=Columns.Add;
        lvColumn.Field:=TField(lvField);
        lvColumn.Width:=100;
      End;
    End;
    Close;
  End;
  lvFieldNames.Free;
  lvClassList.Free;
end;

function TdmClientMain.GetFieldCaption(AFieldName: String): String;
var cv:integer;
begin
  With frmClientMain do
  for cv:=0 to FtsEdit.ControlCount-1 do
  if (FtsEdit.Controls[cv] is TZEDChxBox) and (GetPropValue(FtsEdit.Controls[cv],'KeyField') = AFieldName) then
  Begin
    result:=GetPropValue(FtsEdit.Controls[cv],'Caption');
    break;
  End
  else
  if (FtsEdit.Controls[cv] is TZEDText)
     and  Assigned((FtsEdit.Controls[cv] as TZEDText).FocusControl)
     and  (GetPropValue((FtsEdit.Controls[cv] as TZEDText).FocusControl,'KeyField') = AFieldName) then
  Begin
    result:=(FtsEdit.Controls[cv] as TZEDText).Caption;
    break;
  End;
end;

procedure TdmClientMain.qryGetUserDataCalcFields(DataSet: TDataSet);
var cv:integer;
begin
  for cv:=0 to DataSet.FieldCount-1 do
    if (DataSet.Fields[cv].Calculated) then
      with DataSet.Fields[cv] do
        DataSet.Fields[cv].Value:=DecodeField(DataSet.Fields[cv-1].Value);
end;

function TdmClientMain.DecodeField(ADictinaryID: String): String;
begin
  if ADictinaryID<>'' then
  with qrySearch do
  Begin
    Close;
    SQL.Text:='Select Caption from Dictionary where DictionaryID = '+ADictinaryID;
    Open;
    Result:=Fields[0].AsString;
  End
  else
    Result:='';
end;

function TdmClientMain.isDictionaryField(AFieldName: String): boolean;
begin
  with qrySearch do
  Begin
    Close;
    SQL.Text:='Select * from Fields where FieldName = '#39+AFieldName+#39;
    Open;
    Result:=RecordCount=1;
  End;
end;

initialization
  RegisterClasses([TZEDit,TZEDPicker,TZEDChxBox,TZEDBtn,TZEDText,TfrmClientMain,TStatusBar,TPageControl,TTabSheet,TTimer,TPopupMenu,TStaticText,TSplitter,TDBGrid])
end.
