unit ClientMainDataModule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, ADODB, DBGrids, Grids;

type
  TdmClientMain = class(TDataModule)
    ADOConnection: TADOConnection;
    dtsGetMainData: TDataSource;
    qrySearch: TADOQuery;
    qryGetMainData: TADOQuery;
    dstSearch: TDataSource;
    cmdAlterTable: TADOCommand;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FUserID:integer;
    FUserGroupID:integer;
    function GetFieldType(AFieldName:TCaption):integer;
    procedure FillFieldList(AList:TStrings;AFieldType:TClass;BFieldType:TClass=nil);
    procedure FillDictList(AList:TStrings);
  end;

var
  dmClientMain: TdmClientMain;

const CSelectUserData ='Select UserTable.*, UserGroup.FormData '+
                       'From UserTable, UserGroup '+
                       'Where UserTable.UserGroupID = UserGroup.UserGroupID '+
                       'and UserTable.UserLogin = :@UserLogin '+
                       'and UserTable.UserPasswd = :@UserPasswd';
      CFields ='Select* from Document where DocumentID is null';
      CAlterTable = 'Alter Table Document ';
      CDictionaryGroup = 'Select * from DictionaryGroup';
      CFieldDictionary = 'Select * from Fields';
      CInsertDictGroup = 'Insert into DictionaryGroup (DictionaryGroupName) Values ('#39'%s'#39')';
      CInsertFields = 'Insert into Fields (FieldName,DictionaryGroupID) Values ('#39'%s'#39',%d)';
implementation


uses ZEDit, ZEDPicker, ZEDChxBox, ZEDText, ZEDBtn, comctrls, extctrls, Menus,
     FormEditClientMain, LoginMain, PropertyEditor, Buttons,
     ComponentPalette, SearchList;

{$R *.DFM}

procedure TdmClientMain.DataModuleCreate(Sender: TObject);
var BS:TStream;
    MS:TStream;
    lvEnd,cv:integer;
begin
  frmPasswordDlg:=TfrmPasswordDlg.Create(nil);
  if frmPasswordDlg.ShowModal = mrOK then
  with qrySearch do
  try
    ADOConnection.ConnectionString:='FILE NAME='+ExtractFilePath(ParamStr(0))+'ArchiTekaDSC.udl';
    ADOConnection.Connected:=True;

    SQL.Text:=CSelectUserData;
    Parameters.ParamByName('@UserLogin').Value:=frmPasswordDlg.edtLoginName.Text;
    Parameters.ParamByName('@UserPasswd').Value:=frmPasswordDlg.edtPasswd.Text;
    Open;
    FUserGroupID:=FieldByName('UserGroupID').asInteger;
    FUserID:=FieldByName('UserID').asInteger;
    if RecordCount=1 then
    Begin
      try
        Application.CreateForm(TfrmClientMain,frmClientMain);
        Application.CreateForm(TfrmComonentPalette,frmComonentPalette);
        Application.CreateForm(TfrmPropertyPage,frmPropertyPage);
        Application.CreateForm(TfrmSearchList,frmSearchList);
        BS:=CreateBlobStream(FieldByName('FormData'),bmRead);
        if BS.Size>0 then
        Begin
          for cv:=frmClientMain.ComponentCount-1 downto 0 do
            frmClientMain.Components[cv].Free;
          MS:=TMemoryStream.Create;
          ObjectTextToBinary(BS,MS);
          lvEnd:=0;
          MS.WriteBuffer(lvEnd,SizeOf(lvEnd));
          MS.Seek(0,soFromBeginning);
          MS.ReadComponent(frmClientMain);
        End;
        frmClientMain.Init;
        frmClientMain.Show;
        frmPropertyPage.Top:=frmClientMain.Top;
        frmPropertyPage.Left:=frmClientMain.Left-frmPropertyPage.Width+50;
        frmPropertyPage.Show;
        frmPropertyPage.BringToFront;
        frmComonentPalette.Top:=frmClientMain.Top-frmComonentPalette.Height+50;
        frmComonentPalette.Left:=frmClientMain.Left+50;
        frmComonentPalette.Show;
        frmComonentPalette.BringToFront;
        frmClientMain.Top:=frmClientMain.Top+50;
        frmClientMain.Left:=frmClientMain.Left+50;
        frmClientMain.BringToFront;
        frmPropertyPage.Refill(frmClientMain.ActiveControl);
      finally
        FreeAndNil(BS);
        FreeAndNil(MS);
      End
    end;
    Close;
  except
    Application.Terminate;
  End;
  frmPasswordDlg.free;
end;

function TdmClientMain.GetFieldType(AFieldName: TCaption): integer;
var cv:integer;
begin
  with qrySearch do
  Begin
    Close;
    SQL.Text:=CFields;
    Open;
    result:=-1;
    for cv:=0 to Fields.Count-1 do
    if LowerCase(Fields[cv].FieldName)=AFieldName then
    Begin
      result:=frmClientMain.FFList.IndexOf(Fields[cv].ClassType);
      break;
    End;
  End
end;

procedure TdmClientMain.FillFieldList(AList: TStrings;AFieldType:TClass;BFieldType:TClass=nil);
var cv:integer;
begin
  with qrySearch do
  Begin
    Close;
    SQL.Text:=CFields;
    Open;
    AList.Clear;
    for cv:=1 to Fields.Count-1 do
      if (AFieldType=nil) or (Fields[cv] is AFieldType) or (Fields[cv] is BFieldType) then
      AList.Add(Fields[cv].FieldName);
  end;
end;

procedure TdmClientMain.FillDictList(AList: TStrings);
begin
  with qrySearch do
  Begin
    Close;
    SQL.Text:=CDictionaryGroup;
    Open;
    AList.Clear;
    While not EOF do
    Begin
      AList.Add(FieldByName('DictionaryGroupName').Value);
      Next;
    End;
  end;
end;

initialization
  RegisterClasses([TfrmClientMain,TStatusBar,TPageControl,TTabSheet,TZEDit,
                   TZEDPicker,TZEDChxBox,TZEDText,TTimer,TPopupMenu,TZEDBtn,TSplitter,TDBGrid])
end.
