unit ComponentPalette;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons, ExtCtrls;

type
  TfrmComonentPalette = class(TForm)
    SpeedButton4: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton2: TSpeedButton;
    btnArrow: TSpeedButton;
    btnSave: TSpeedButton;
    btnOpen: TSpeedButton;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure btnArrowClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FClassItem:integer;
  end;

var
  frmComonentPalette: TfrmComonentPalette;

const
  CSelectUserGroups = 'Select * from UserGroup';
implementation

uses TypInfo, PropertyEditor, FormEditClientMain, SearchList, ClientMainDataModule, DB, variants;

{$R *.DFM}

procedure TfrmComonentPalette.FormCreate(Sender: TObject);
begin
  FClassItem:=-1;
end;

procedure TfrmComonentPalette.btnArrowClick(Sender: TObject);
begin
  FClassItem:=TComponent(Sender).Tag;
end;

procedure TfrmComonentPalette.btnSaveClick(Sender: TObject);
var DS:TStream;
    MS:TStream;
    lvTop,lvLeft,cv:integer;
    lvKeyField,lvDictGroup:variant;
    lvDictGroupID:integer;
    lvFieldType:integer;
begin
  with dmClientMain.qrySearch do
  Begin
    Close;
    SQL.Text:=CSelectUserGroups;
    Open;
    Fields[0].Visible:=False;
    Fields[2].Visible:=False;
    FieldByName('UserGroupName').DisplayLabel:='Felhasznli csoport';
  End;
  frmSearchList.dbgSearch.DataSource:=dmClientMain.dstSearch;
  frmSearchList.FDisplayField:='UserGroupName';
  if frmSearchList.ShowModal=mrOK then
  try
    frmClientMain.ClearEvents;
    lvLeft:=frmClientMain.Top;
    lvTop:=frmClientMain.Left;
    frmClientMain.OnShow:=nil;
    frmClientMain.Position:=poScreenCenter;
    frmClientMain.OnShow:=frmClientMain.FormShow;
    dmClientMain.qrySearch.Edit;
    dmClientMain.qrySearch.FieldByName('FormData').Value:=null;
    dmClientMain.qrySearch.Post;
    dmClientMain.qrySearch.Edit;

    DS:=dmClientMain.qrySearch.CreateBlobStream(dmClientMain.qrySearch.FieldByName('FormData'),bmReadWrite);
    MS:=TMemoryStream.Create;
    MS.WriteComponent(frmClientMain);
    MS.Seek(0,soFromBeginning);
    ObjectBinaryToText(MS,DS);
    DS.Free;
    dmClientMain.qrySearch.Post;
    frmClientMain.LoadUpEvents;
    frmClientMain.Top:=lvLeft;
    frmClientMain.Left:=lvTop;
  finally
    FreeAndNil(MS);
  End;
  for cv:=0 to frmClientMain.ComponentCount-1 do
  Begin
    try
      lvKeyField:=GetPropValue(frmClientMain.Components[cv],'KeyField');
    except
      lvKeyField:='';
    end;
    try
      lvDictGroup:=GetPropValue(frmClientMain.Components[cv],'Dictionary');
    except
      lvDictGroup:='';
    end;
    if not VarIsNull(lvKeyField) and (lvKeyField<>'')
      and not Boolean(dmClientMain.GetFieldType(LowerCase(lvKeyField))+1) then
    with dmClientMain.cmdAlterTable do
    try
      lvFieldType:=GetPropValue(frmClientMain.Components[cv],'FieldType');
      case lvFieldType of
        0,1:Begin
              if (lvDictGroup='') and (lvFieldType=1) then
                CommandText:=CAlterTable+'Add ['+lvKeyField+'] varchar(50) '
              else
                CommandText:=CAlterTable+'Add ['+lvKeyField+'] int ';
            End;
        2: CommandText:=CAlterTable+'Add ['+lvKeyField+'] datetime ';
        3: CommandText:=CAlterTable+'Add ['+lvKeyField+'] binary(1) ';
      end;
      Execute;
    except
    End;

    if not VarIsNull(lvDictGroup) and (lvDictGroup<>'') then
    with dmClientMain.qrySearch do
    Begin
      Close;
      SQL.Text:=CDictionaryGroup;
      Open;
      if not Locate('DictionaryGroupName',lvDictGroup,[loCaseInsensitive]) then
      Begin
        dmClientMain.cmdAlterTable.CommandText:=Format(CInsertDictGroup,[lvDictGroup]);
        dmClientMain.cmdAlterTable.Execute;
      End;
      Close;
      Open;
      Locate('DictionaryGroupName',lvDictGroup,[loCaseInsensitive]);
      lvDictGroupID:=FieldByName('DictionaryGroupID').Value;
      Close;
      SQL.Text:=CFieldDictionary;
      Open;
      if not Locate('FieldName',lvKeyField,[loCaseInsensitive]) then
      Begin
        dmClientMain.cmdAlterTable.CommandText:=Format(CInsertFields,[lvKeyField,lvDictGroupID]);
        dmClientMain.cmdAlterTable.Execute;
      End;
    End;
  End;
  frmPropertyPage.Refill(frmClientMain.ActiveControl);
end;

procedure TfrmComonentPalette.btnOpenClick(Sender: TObject);
var BS:TStream;
    MS:TStream;
    lvEnd,cv,lvTop,lvLeft:integer;
begin
  with dmClientMain.qrySearch do
  Begin
    Close;
    SQL.Text:=CSelectUserGroups+' where FormData is not null';
    Open;
    Locate('UserGroupID',dmClientMain.FUserGroupID,[]);
    Fields[0].Visible:=False;
    Fields[2].Visible:=False;
    FieldByName('UserGroupName').DisplayLabel:='Felhasznli csoport';
  End;
  frmSearchList.dbgSearch.DataSource:=dmClientMain.dstSearch;
  frmSearchList.FDisplayField:='UserGroupName';
  if frmSearchList.ShowModal=mrOK then
  Begin
    dmClientMain.FUserGroupID:=dmClientMain.qrySearch.FieldByName('UserGroupID').asInteger;
    frmClientMain.ClearEvents;
    try
      BS:=dmClientMain.qrySearch.CreateBlobStream(dmClientMain.qrySearch.FieldByName('FormData'),bmRead);
      MS:=nil;
      if BS.Size>0 then
      Begin
        MS:=TMemoryStream.Create;
        ObjectTextToBinary(BS,MS);
        lvEnd:=0;
        MS.WriteBuffer(lvEnd,SizeOf(lvEnd));
        MS.Seek(0,soFromBeginning);
        for cv:=frmClientMain.ComponentCount-1 downto 0 do
          frmClientMain.Components[cv].Free;
        lvTop:=frmClientMain.Top;
        lvLeft:=frmClientMain.Left;
        MS.ReadComponent(frmClientMain);
        frmClientMain.Init;
        frmClientMain.Top:=lvTop;
        frmClientMain.Left:=lvLeft;
      End;
    finally
      FreeAndNil(BS);
      FreeAndNil(MS);
    End;
  End;
end;

end.
