unit FormEditClientMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, ClientMainDataModule,
  Forms, Controls, Contnrs, Menus, ExtCtrls, ComCtrls, StdCtrls, Buttons,
  Grids, DBGrids, ZEDBtn;

type
  TfrmClientMain = class(TForm)
    btnPrint: TBitBtn;
    procedure tsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ZEDPickerDropDownCloseUp(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComponentMouseMove(Sender: TObject; Shift: TShiftState; X,  Y: Integer);
    procedure ComponentMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ComponentMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ControlKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure ControlKeyPress(Sender: TObject; var Key: Char);
    procedure ComponentEnter(Sender: TObject);
    procedure HintTimeTimer(Sender: TObject);
    procedure pmiDeleteClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure btnModifyClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure dbgSearchDblClick(Sender: TObject);
  private
    { Private declarations }
    DX,DY:integer;
    FOPoint:TPoint;
    FOldChecked:Boolean;
    FClosedUp:Boolean;
    FEditMode:Boolean;
    FMovedControl:TWinControl;
  public
    { Public declarations }
    FCList:TClassList;
    FFList:TClassList;
    CompPopup: TPopupMenu;
    pmiDelete: TMenuItem;
    procedure LoadUpEvents;
    procedure LoadUpCompEvents(Comp:TComponent);
    procedure ClearEvents;
    procedure ClearCompEvents(Comp:TComponent);
    procedure Init;
  end;

var
  frmClientMain: TfrmClientMain;

implementation
uses ZEDit,ZEDPicker,ZEDChxBox, ZEDText,PropertyEditor, Math,
     TypInfo, ComponentPalette, DB;

{$R *.DFM}
procedure TfrmClientMain.tsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Type TLocalClass=class of TControl;
var cv:integer;
    lvSeekForName:boolean;
begin
  FMovedControl:=nil;

  if frmComonentPalette.FClassItem>-1 then
  with frmPropertyPage do
  Begin
    FFieldControl:=TLocalClass(FCList.Items[frmComonentPalette.FClassItem]).Create(frmClientMain);
    FFieldControl.Parent:=TWinControl(Sender);
    cv:=1;
    lvSeekForName:=True;
    while lvSeekForName do
    try
      FFieldControl.Name:=FFieldControl.ClassName+IntToStr(cv);
      lvSeekForName:=false;
    except
      inc(cv);
    end;
    FFieldControl.Top:=Y;
    FFieldControl.Left:=X;
    if (FFieldControl is TZEDit) then
      (FFieldControl as TZEDit).Text:='';
    SetPropValue(FFieldControl,'Tag',1);
    if (FFieldControl is TZEDit) or (FFieldControl is TZEDPicker) then
    Begin
      FStaticText:=TZEDText.Create(frmClientMain);
      FStaticText.Parent:=TWinControl(Sender);
      cv:=1;
      lvSeekForName:=True;
      while lvSeekForName do
      try
        FStaticText.Name:=FStaticText.ClassName+IntToStr(cv);
        lvSeekForName:=false;
      except
        inc(cv);
      end;
      TZEDText(FStaticText).Caption:='Meznv:';
      FStaticText.Top:=Y+4;
      FStaticText.Left:=X-(Canvas.TextWidth('Meznv:')+4);
      SetObjectProp(FStaticText,'FocusControl',FFieldControl);
      TZEDText(FStaticText).OnMouseDown:=ComponentMouseDown;
      TZEDText(FStaticText).OnMouseMove:=ComponentMouseMove;
      TZEDText(FStaticText).OnMouseUp:=ComponentMouseUp;
      TZEDText(FStaticText).PopupMenu:=CompPopup;
    End
    else
    Begin
      SetPropValue(FFieldControl,'Caption','Meznv:');
      FStaticText:=FFieldControl;
    End;

    LoadUpCompEvents(FFieldControl);

    frmComonentPalette.btnArrow.Down:=True;
    frmComonentPalette.FClassItem:=-1;
    if not(FFieldControl is TZEDText) then
      TWinControl(FFieldControl).SetFocus
    else
      Refill(FFieldControl);
  End;
end;

procedure TfrmClientMain.FormShow(Sender: TObject);
begin
  frmComonentPalette.Show;
  frmPropertyPage.Show;
end;

procedure TfrmClientMain.FormHide(Sender: TObject);
begin
  frmComonentPalette.Hide;
end;

procedure TfrmClientMain.FormDestroy(Sender: TObject);
begin
  FCList.Free;
  FFList.Free;
end;

procedure TfrmClientMain.ComponentMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var lvDx,lvDy:integer;
    lvMaxX,lvMaxY:integer;
begin
  if Assigned(FMovedControl) then
  Begin
    FOPoint:=FMovedControl.Parent.ScreenToClient(Mouse.CursorPos);
    Y:=((FOPoint.Y-DY) div 4)*4;
    X:=((FOPoint.X-DX) div 4)*4;

    lvMaxX:=TWinControl(FMovedControl.Parent).ClientWidth;
    lvMaxY:=TWinControl(FMovedControl.Parent).ClientHeight;

    if (FMovedControl is TZEDText) and assigned(TZEDText(FMovedControl).FocusControl) then
    Begin
      lvDy:=TZEDText(FMovedControl).Top-TZEDText(FMovedControl).FocusControl.Top;
      lvDx:=TZEDText(FMovedControl).Left-TZEDText(FMovedControl).FocusControl.Left;
      lvMaxY:=lvMaxY-Max(TZEDText(FMovedControl).FocusControl.Height-lvDy,FMovedControl.Height);
      lvMaxX:=lvMaxX-Max(TZEDText(FMovedControl).FocusControl.Width-lvDX,FMovedControl.Width);
    End
    else
    Begin
      lvDy:=0;
      lvDx:=0;
      lvMaxX:=lvMaxX-FMovedControl.Width;
      lvMaxY:=lvMaxY-FMovedControl.Height;
    End;

    if  (X>0) and ((X-lvDx)>0) and (X<lvMaxX) then
    Begin
      TControl(FMovedControl).Left:=X;
      if (FMovedControl is TZEDText) and assigned(TZEDText(FMovedControl).FocusControl) then
        TZEDText(FMovedControl).FocusControl.Left:=X-lvDx;
    End;
    if (Y>0) and ((Y-lvDy)>0) and (Y<lvMaxY) then
    Begin
      TControl(FMovedControl).Top:=Y;
      if (FMovedControl is TZEDText) and assigned(TZEDText(FMovedControl).FocusControl) then
        TZEDText(FMovedControl).FocusControl.Top:=Y-lvDy;
    End;
  End;
end;

procedure TfrmClientMain.ComponentMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button=mbLeft) and (frmComonentPalette.FClassItem=-1) and not(sender is TTabSheet) and not(FClosedUp) then
  Begin
    FMovedControl:=TWinControl(Sender);
    FOPoint:=FMovedControl.ScreenToClient(Mouse.CursorPos);
    DX:=FOPoint.X;
    DY:=FOPoint.Y;
    if (Sender is TZEDChxBox) then
        FOldChecked:=TZEDChxBox(Sender).Checked;
  End
  else
  Begin
    FClosedUp:=False;
    FMovedControl:=nil;
  End;
end;

procedure TfrmClientMain.ComponentMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Sender is TZEDChxBox) then
    TZEDChxBox(Sender).Checked:=FOldChecked;
  FMovedControl:=nil;
  if not frmPropertyPage.FHWin.Visible then
  Begin
    with frmPropertyPage do
    if (FFieldControl<>Sender) then
    Begin
      Refill(Sender);
    End;
  End;
end;

procedure TfrmClientMain.ControlKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssAlt in Shift) then
    if (ssCtrl in Shift) then
    case key of
      VK_RIGHT: TControl(Sender).Width:=TControl(Sender).Width+4;
      VK_LEFT : TControl(Sender).Width:=TControl(Sender).Width-4;
      VK_UP   : TControl(Sender).Height:=TControl(Sender).Height-4;
      VK_DOWN : TControl(Sender).Height:=TControl(Sender).Height+4;
    end
    else
    case key of
      VK_RIGHT: TControl(Sender).Left:=TControl(Sender).Left+4;
      VK_LEFT : TControl(Sender).Left:=TControl(Sender).Left-4;
      VK_UP   : TControl(Sender).Top:=TControl(Sender).Top-4;
      VK_DOWN : TControl(Sender).Top:=TControl(Sender).Top+4;
    end;
  if FEditMode then
    Key:=0;
end;

procedure TfrmClientMain.ZEDPickerDropDownCloseUp(Sender: TObject);
begin
  FClosedUp:=True;
end;

procedure TfrmClientMain.ComponentEnter(Sender: TObject);
begin
  frmPropertyPage.Refill(Sender);
end;

procedure TfrmClientMain.ControlKeyPress(Sender: TObject; var Key: Char);
begin
  if FEditMode then
    Key:=#0;
end;

procedure TfrmClientMain.HintTimeTimer(Sender: TObject);
begin
  //Timer
end;

procedure TfrmClientMain.pmiDeleteClick(Sender: TObject);
begin
  if (CompPopup.PopupComponent is TZEDText) and assigned(TZEDText(CompPopup.PopupComponent).FocusControl) then
    TZEDText(CompPopup.PopupComponent).FocusControl.Free;
  CompPopup.PopupComponent.Free;
  frmPropertyPage.Refill(nil);
end;

procedure TfrmClientMain.ClearEvents;
var cv:integer;
    lvtsEdit:TTabSheet;
    lvtsSearch:TTabSheet;
begin
  lvtsEdit:=TTabSheet(FindComponent('tsEdit'));
  lvtsEdit.OnMouseMove:=nil;
  lvtsEdit.OnMouseUp:=nil;
  lvtsSearch:=TTabSheet(FindComponent('tsSearch'));
  lvtsSearch.OnMouseMove:=nil;
  lvtsSearch.OnMouseUp:=nil;
  frmClientMain.OnCreate:=nil;
  frmClientMain.OnDestroy:=nil;
  frmClientMain.OnHide:=nil;
  //frmClientMain.OnShow:=nil;
  for cv:=0 to lvtsEdit.ControlCount-1 do
      ClearCompEvents(lvtsEdit.Controls[cv]);

  for cv:=0 to lvtsSearch.ControlCount-1 do
      ClearCompEvents(lvtsSearch.Controls[cv]);
  FreeAndNil(CompPopup);
end;

procedure TfrmClientMain.LoadUpEvents;
var cv:integer;
    lvtsEdit:TTabSheet;
    lvtsSearch:TTabSheet;
begin
  CompPopup:=TPopupMenu.Create(Self);
  CompPopup.Name:='CompPopup';
  pmiDelete:=TMenuItem.Create(CompPopup);
  pmiDelete.Caption:='Trls';
  pmiDelete.OnClick:=pmiDeleteClick;
  CompPopup.Items.Add(pmiDelete);

  lvtsEdit:=TTabSheet(FindComponent('tsEdit'));
  if assigned(lvtsEdit) then
  Begin
    lvtsEdit.OnMouseMove:=ComponentMouseMove;
    lvtsEdit.OnMouseUp:=tsMouseUp;
    for cv:=0 to lvtsEdit.ControlCount-1 do
        LoadUpCompEvents(lvtsEdit.Controls[cv]);
  End;
  lvtsSearch:=TTabSheet(FindComponent('tsSearch'));
  if assigned(lvtsSearch) then
  Begin
    lvtsSearch.OnMouseMove:=ComponentMouseMove;
    lvtsSearch.OnMouseUp:=tsMouseUp;
    for cv:=0 to lvtsSearch.ControlCount-1 do
        LoadUpCompEvents(lvtsSearch.Controls[cv])
  End;
  frmClientMain.OnDestroy:=FormDestroy;
  frmClientMain.OnHide:=FormHide;
  frmClientMain.OnShow:=FormShow;
end;

procedure TfrmClientMain.Init;
begin
  FEditMode:=True;
  FMovedControl:=nil;
  FCList:=TClassList.Create;
  FCList.Add(TZEDit);
  FCList.Add(TZEDText);
  FCList.Add(TZEDPicker);
  FCList.Add(TZEDChxBox);
  FFList:=TClassList.Create;
  FFList.Add(TIntegerField);
  FFList.Add(TStringField);
  FFList.Add(TDateTimeField);
  FFList.Add(TBytesField);//TBinaryField
  FFList.Add(TField);
  LoadUpEvents
end;

procedure TfrmClientMain.LoadUpCompEvents(Comp:TComponent);
var lvMethod:TMethod;
begin
  lvMethod.Data:=Self;

  lvMethod.Code:=Self.MethodAddress('ComponentMouseDown');
  SetMethodProp(Comp,'OnMouseDown',lvMethod);

  lvMethod.Code:=Self.MethodAddress('ComponentMouseMove');
  SetMethodProp(Comp,'OnMouseMove',lvMethod);

  lvMethod.Code:=Self.MethodAddress('ComponentMouseUp');
  SetMethodProp(Comp,'OnMouseUp',lvMethod);

  SetObjectProp(Comp,'PopupMenu',CompPopup);

  if not(Comp is TZEDText) then
  Begin
    lvMethod.Code:=Self.MethodAddress('ControlKeyDown');
    SetMethodProp(Comp,'OnKeyDown',lvMethod);

    lvMethod.Code:=Self.MethodAddress('ControlKeyPress');
    SetMethodProp(Comp,'OnKeyPress',lvMethod);

    lvMethod.Code:=Self.MethodAddress('ComponentEnter');
    SetMethodProp(Comp,'OnEnter',lvMethod);
  End;

  if (Comp is TZEDPicker) then
  Begin
    lvMethod.Code:=Self.MethodAddress('ZEDPickerDropDownCloseUp');
    SetMethodProp(Comp,'OnDropDown',lvMethod);
    SetMethodProp(Comp,'OnCloseUp',lvMethod);
  End;

  lvMethod.Code:=nil;
  lvMethod.Data:=nil;
  if (Comp is TBitBtn) then
    SetMethodProp(Comp,'OnClick',lvMethod);
end;

procedure TfrmClientMain.ClearCompEvents(Comp: TComponent);
var lvMethod:TMethod;
begin
  lvMethod.Data:=nil;
  lvMethod.Code:=nil;

  SetMethodProp(Comp,'OnMouseDown',lvMethod);
  SetMethodProp(Comp,'OnMouseMove',lvMethod);
  SetMethodProp(Comp,'OnMouseUp',lvMethod);

  if not(Comp is TZEDText) then
  Begin
    SetMethodProp(Comp,'OnKeyDown',lvMethod);
    SetMethodProp(Comp,'OnKeyPress',lvMethod);
    SetMethodProp(Comp,'OnEnter',lvMethod);
  End;

  if (Comp is TZEDPicker) then
  Begin
    SetMethodProp(Comp,'OnDropDown',lvMethod);
    SetMethodProp(Comp,'OnCloseUp',lvMethod);
  End;

  if (Comp is TBitBtn) then
  Begin
    lvMethod.Data:=Self;
    lvMethod.Code:=Self.MethodAddress(Comp.Name+'Click');
    SetMethodProp(Comp,'OnClick',lvMethod);
  End;

  SetPropValue(Comp,'Tag',0);
end;

procedure TfrmClientMain.btnSearchClick(Sender: TObject);
begin
  //SQLBuild
end;

procedure TfrmClientMain.btnNewClick(Sender: TObject);
begin
  //ClearFields
end;

procedure TfrmClientMain.btnModifyClick(Sender: TObject);
begin
  //Modify
end;

procedure TfrmClientMain.btnSaveClick(Sender: TObject);
begin
  //Save
end;

procedure TfrmClientMain.btnCancelClick(Sender: TObject);
begin
  //Cancel
end;

procedure TfrmClientMain.btnPrintClick(Sender: TObject);
begin
   //rem
end;

procedure TfrmClientMain.dbgSearchDblClick(Sender: TObject);
begin
  //rem
end;

end.
