unit ZEDChxBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TZEDChxBox = class(TCheckBox)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FKeyField:TCaption;
    FRelation:TCaption;
    FRequired:Boolean;
    FCanModify:Boolean;
    FEmpty:Boolean;
    FState:integer;
    FFieldType: integer;
    function isValid:Boolean;
    function isEmpty:Boolean;
    procedure SetEmpty(Value:Boolean);
    procedure SetState(Value:integer);
    function GetFieldType:integer;
    function GetValue:string;
    procedure SetValue(const Value:string);
  public
    { Public declarations }
  published
    { Published declarations }
    property KeyField:TCaption read FKeyField write FKeyField;
    property FieldValue:string read GetValue write SetValue stored false;
    property Relation:TCaption read FRelation write FRelation;
    property Required:Boolean read FRequired write FRequired;
    property CanModify:Boolean read FCanModify write FCanModify;
    property FieldType:integer read GetFieldType write FFieldType;
    property Empty:Boolean read isEmpty write SetEmpty stored false;
    property Validate:Boolean read IsValid stored false;
    property State:integer read FState write SetState stored false;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Z_Components', [TZEDChxBox]);
end;

{ TZEDChxBox }

function TZEDChxBox.GetFieldType: integer;
begin
  Result:=3;
end;

function TZEDChxBox.GetValue: string;
begin
  result:=intToStr(Integer(Checked));
end;

function TZEDChxBox.isEmpty: Boolean;
begin
  Result:=False;
end;

function TZEDChxBox.isValid: Boolean;
begin
  Result:=True;
end;

procedure TZEDChxBox.SetEmpty(Value: Boolean);
begin
  Checked:=False;
end;

procedure TZEDChxBox.SetState(Value: integer);
begin
  Enabled:=(Value=3) or ((Value=2) and FCanModify);
  if Value in [0,3] then
    Checked:=False;
  FState:=Value;
end;

procedure TZEDChxBox.SetValue(const Value: String);
begin
  try
    Checked:=Boolean(StrToInt(Value));
  except
    Checked:=false;
  end
end;

end.
