unit ZEDPicker;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

type
  TZEDPicker = class(TDateTimePicker)
  private
    FDictionary: TCaption;
    { Private declarations }
  protected
    { Protected declarations }
    FKeyField:TCaption;
    FRelation:TCaption;
    FRequired:Boolean;
    FCanModify:Boolean;
    FEmpty:Boolean;
    FState:integer;
    FFieldType: integer;
    function isValid:Boolean;
    function isEmpty:Boolean;
    procedure SetEmpty(Value:Boolean);
    procedure SetState(Value:integer);
    function GetFieldType:integer;
    function GetValue: String;
    procedure SetValue(const Value: String);
  public
    { Public declarations }
    constructor Create(Owner:TComponent);override;
  published
    { Published declarations }
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property Date stored false;
    property ShowCheckbox default true;
    property KeyField:TCaption read FKeyField write FKeyField;
    property FieldValue:String read GetValue write SetValue stored false;
    property Dictionary:TCaption read FDictionary write FDictionary;
    property Relation:TCaption read FRelation write FRelation;
    property Required:Boolean read FRequired write FRequired;
    property CanModify:Boolean read FCanModify write FCanModify;
    property FieldType:integer read GetFieldType write FFieldType;
    property Empty:Boolean read isEmpty write SetEmpty stored false;
    property Validate:Boolean read IsValid stored false;
    property State:integer read FState write SetState stored false;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Z_Components', [TZEDPicker]);
end;

{ TZEDPicker }

constructor TZEDPicker.Create(Owner: TComponent);
begin
  inherited;
  Width:=96;
  ShowCheckbox:=True;
end;

function TZEDPicker.GetFieldType: integer;
begin
  Result:=2;
end;

function TZEDPicker.GetValue: String;
begin
  Result:=FormatDateTime(ShortDateFormat,Date);
end;

function TZEDPicker.isEmpty: Boolean;
begin
  Result:=not Checked;
end;

function TZEDPicker.isValid: Boolean;
begin
  Result:=not FRequired or Checked;
end;

procedure TZEDPicker.SetEmpty(Value: Boolean);
begin
  Checked:=False;
end;

procedure TZEDPicker.SetState(Value: integer);
begin
  Enabled:=(Value=3) or ((Value=2) and FCanModify);
  FState:=Value;
  if Value in [0,3] then
  Begin
    Checked:=False;
    Date:=SysUtils.Date;
  End;
end;

procedure TZEDPicker.SetValue(const Value: String);
begin
  try
    Date:=StrToDate(StringReplace(Value,'.',DateSeparator,[rfReplaceAll]));
    Checked:=True;
  except
    Checked:=False;
  end
end;

end.
