unit ZEDit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TZEDit = class(TEdit)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FKeyField:TCaption;
    FFieldValue:Variant;
    FDictionary:TCaption;
    FRelation:TCaption;
    FRequired:Boolean;
    FCanModify:Boolean;
    FFieldType:integer;
    FEmpty:Boolean;
    FState:Integer;
    function isValid:Boolean;
    function isEmpty:Boolean;
    procedure SetEmpty(Value:Boolean);
    procedure SetState(Value:integer);
    function GetValue: Variant;
    procedure SetValue(const Value: Variant);
  public
    { Public declarations }
  published
    { Published declarations }
    property KeyField:TCaption read FKeyField write FKeyField;
    property FieldValue:Variant read GetValue write SetValue stored false;
    property Dictionary:TCaption read FDictionary write FDictionary;
    property Relation:TCaption read FRelation write FRelation;
    property Required:Boolean read FRequired write FRequired;
    property CanModify:Boolean read FCanModify write FCanModify;
    property FieldType:integer read FFieldType write FFieldType;
    property Empty:Boolean read isEmpty write SetEmpty stored false;
    property Validate:Boolean read IsValid stored false;
    property State:integer read FState write SetState stored false;
  end;

procedure Register;

implementation
uses variants;

procedure Register;
begin
  RegisterComponents('Z_Components', [TZEDit]);
end;

{ TZEDit }

function TZEDit.GetValue: variant;
begin
  if FDictionary='' then
    Result:=Text
  else
    Result:=FFieldValue
end;

function TZEDit.isEmpty: Boolean;
begin
  Result:=VarToStr(FieldValue)='';
end;

function TZEDit.isValid: Boolean;
begin
  Result:=True;
  if (FFieldType=0) then
  try
    if not isEmpty then
      StrToFloat(Text);
  except
    Result:=False;
  end
end;

procedure TZEDit.SetEmpty(Value: Boolean);
begin
  Text:='';
end;

procedure TZEDit.SetState(Value: integer);
begin
  Enabled:=(Value=3) or ((Value=2) and FCanModify);
  FState:=Value;
  if Value in [0,3] then
    Text:='';
end;

procedure TZEDit.SetValue(const Value: Variant);
begin
  if FDictionary='' then
    Text:=VarToStr(Value)
  else
    FFieldValue:=Value;
end;

end.
